import React, { Component } from 'react';
import Hobby from './components/Hobby';
import './App.css';

class App extends Component {
  constructor(props) {
    super(props);
      // déclarer un état...
    		// modele, equivalent du data de VueJS
    		this.state = {
    		  hobbies: {
            hobby0:'tennis',
            hobby1:'foot',
            hobby2:'jeux vidéo'
          }
        }
  }
  addHobby() {
    const copieHobbies = {...this.state.hobbies}; // spread operator
                                                  // permet de cloner des objets
    copieHobbies['hobby' + Math.random()] = this.input.value;
    
		this.setState({
			hobbies: copieHobbies
    });
    this.input.value = '';
  }

  removeHobby(key) {
    const copieHobbies = {...this.state.hobbies};
    delete copieHobbies[key];

    this.setState({
			hobbies: copieHobbies
    });
  };
  
  
  // méthodes
  render() {
    let listeHobbies = Object.keys(this.state.hobbies).map((key, index) => { 
      let el = this.state.hobbies[key];
      return <Hobby key={index}
                cle={key}
                name={el}
                removeHobby={this.removeHobby.bind(this)}
             >
             {el}
             </Hobby>
    });
    /*
    let listeHobbies = this.state.hobbies.map(
      (el, index) => {
        return <Hobby key={index}
                      name={el}
                      removeHobby={this.removeHobby.bind(this)}
               >
              {el}
              </Hobby>
      }
    );
    */
    return (
      <div id="app">
        <h1>Liste des hobbies:</h1>
            <p> Nombre de Hobbies: {this.state.hobbies.length} </p>
        <ul>
          {listeHobbies}
        </ul>
        <input
               ref={(input) => this.input = input}
               type="text" 
               placeholder="Ecrivez une hobby .."/>
		    <button onClick={() => this.addHobby()}>Nouveau Hobby</button>

      </div>
    );
  }
}

export default App;
